%global svn_revision 3589
%global svn_date 20230220

Name:           kBuild
Version:        0.1.9998
Release:    2%{?dist}
Summary:        A cross-platform build environment

License:        BSD and GPLv2+
URL:            http://svn.netlabs.org/kbuild
Source0:        kBuild-r%{svn_revision}.%{svn_date}.tar.gz
Patch0:         kBuild-0.1.3-escape.patch
Patch1:         kBuild-pthread.patch
Patch6:         kbuild-dummy_noreturn.diff
Patch10:        assert.patch
Patch12:        kBuild-configure-c99.patch
Patch13:        kBuild-c99.patch

BuildRequires:  make
BuildRequires:  gcc
BuildRequires:  automake
BuildRequires:  bison
BuildRequires:  gettext-devel
BuildRequires:  libtool
BuildRequires:  flex
BuildRequires:  libacl-devel
BuildRequires:  texinfo
BuildRequires:  byacc

%description
This is a GNU make fork with a set of scripts to simplify
complex tasks and portable versions of various UNIX tools to
ensure cross-platform portability.

It is used mainly to build VirtualBox packages for RPM Fusion
repository.


%prep
%setup -q -n %{name}
%patch0 -p1 -b .escape
%patch1 -p1 -b .pthreads
%patch6 -p1 -b .dummy_noreturn
%patch10 -p1 -b .portme3
%patch12 -p1
%patch13 -p1

%build
echo KBUILD_SVN_URL := http://svn.netlabs.org/repos/kbuild/trunk  >  SvnInfo.kmk
echo KBUILD_SVN_REV := %{svn_revision} >>  SvnInfo.kmk

%define bootstrap_mflags %{_smp_mflags} \\\
        CFLAGS="%{optflags}"            \\\
        KBUILD_VERBOSE=2                \\\
        KBUILD_VERSION_PATCH=9998

%define mflags %{bootstrap_mflags}      \\\
        NIX_INSTALL_DIR=%{_prefix}      \\\
        BUILD_TYPE=release              \\\
        MY_INST_MODE=0644               \\\
        MY_INST_BIN_MODE=0755

find -name config.log -delete
kBuild/env.sh --full make -f bootstrap.gmk %{bootstrap_mflags}
kBuild/env.sh kmk %{mflags} rebuild


%install
export KBUILD_VERBOSE=2
kBuild/env.sh kmk %{mflags} PATH_INS=%{buildroot} install
rm -r %{buildroot}%{_docdir}
mkdir -p %{buildroot}/%{_mandir}/man1
pod2man -c 'kBuild for Fedora/EPEL GNU/Linux' \
  -r kBuild-%{version} ./dist/debian/kmk.pod > %{buildroot}/%{_mandir}/man1/kmk.1


%files
%doc ChangeLog kBuild/doc/QuickReference*
%license COPYING kBuild/doc/COPYING-FDL-1.3
%{_bindir}/*
%{_datadir}/kBuild
%{_mandir}/man1/*


%changelog
* Tue May 07 2024 Fanjun Kong <fanjunkong@tencent.com> - 0.1.9998-2
- epol debrand

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.1.9998-1
- initial build
